﻿Type=StaticCode
Version=1
ModulesStructureVersion=1
B4R=true
@EndOfDesignText@


Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.

	Type ToneState (Freq As Int, Duration As UInt)
	Dim ToneIndex As Int = 0
	Dim ToneStates(20) As ToneState
	Private ToneOn As Boolean=False
	Private D As ULong=0
	Dim Sound As Pin
End Sub

Sub Init(Pin As Byte)
	ToneOn=False
    Sound.Initialize(Pin,Sound.MODE_OUTPUT)
	ToneIndex = 0
	AddLooper("Toneloop")
End Sub

Sub Clear()
	ToneIndex = 0
End Sub

Sub Add(Freq As Int, Duration As UInt)
	If ToneIndex < 20 Then
		Dim State As ToneState = ToneStates(ToneIndex)
		State.Freq=Freq
		State.Duration=Duration
		ToneIndex=ToneIndex+1
	End If
End Sub

Sub Play()
	CallSubPlus("PlayTone",0,0)
End Sub

Sub Stop()
	ToneOn=False
End Sub

private Sub PlayTone(Index As Byte)
	If Index<ToneIndex Then
		Dim State As ToneState = ToneStates(Index)
		If State.Freq=0 Then
			ToneOn=False
		Else
		    d = 500000/State.Freq
			ToneOn=True
		End If	
		Dim stat As Byte = Index+1	
		CallSubPlus("PlayTone",State.Duration,stat)
	Else
		ToneOn=False
	End If
End Sub

Private Sub Toneloop
	If ToneOn Then
        Sound.digitalWrite(True)
        DelayMicroseconds(d)
        Sound.digitalWrite(False)
        DelayMicroseconds(d)
	End If
End Sub



